searchData={"items":[{"type":"module","title":"nova","doc":"Interface module for nova","ref":"nova.html"},{"type":"function","title":"nova.get_apps/0","doc":"Returns a proplist with all nova applications and their prefix. This function is useful when calulating dynamic routes.","ref":"nova.html#get_apps/0"},{"type":"function","title":"nova.get_env/2","doc":"Works as the regular application:get_env/3 but instead of giving a specific application we target the application that started nova.","ref":"nova.html#get_env/2"},{"type":"function","title":"nova.get_environment/0","doc":"Returns which environment nova is started in. This fetches the environment-variable in sys.config for Nova and returns the value found. Defaults to: dev","ref":"nova.html#get_environment/0"},{"type":"function","title":"nova.get_main_app/0","doc":"Returns the name of the main bw-application (The one that started everything)","ref":"nova.html#get_main_app/0"},{"type":"function","title":"nova.set_env/2","doc":"Sets an environment variable for the main application.","ref":"nova.html#set_env/2"},{"type":"function","title":"nova.use_stacktrace/1","doc":"Enables or disables stacktraces. This is a global setting and affects all requests. If stacktraces are enabled, nova will try to print a stacktrace when an exception is thrown.","ref":"nova.html#use_stacktrace/1"},{"type":"type","title":"nova.state/0","doc":null,"ref":"nova.html#t:state/0"},{"type":"module","title":"nova_app","doc":"Nova application behaviour callback (Not used)","ref":"nova_app.html"},{"type":"function","title":"nova_app.start/2","doc":null,"ref":"nova_app.html#start/2"},{"type":"function","title":"nova_app.stop/1","doc":null,"ref":"nova_app.html#stop/1"},{"type":"module","title":"nova_basic_handler","doc":null,"ref":"nova_basic_handler.html"},{"type":"function","title":"nova_basic_handler.handle_json/3","doc":"Handler for JSON. It takes two different return objects: {json, JSON :: map()} returns the JSON encoded to the user. If the operation was a POST the HTTP-status code will be 201, otherwise 200. {json, StatusCode :: integer(), Headers :: map(), JSON :: map()} Same operation as the above except you can set custom status code and custom headers.","ref":"nova_basic_handler.html#handle_json/3"},{"type":"function","title":"nova_basic_handler.handle_ok/3","doc":"Handler for regular views. This will render a template with given variables. If not another view is specified in options a view that corresponds to the controller will be rendered. The first element of the returned tuple could be either ok or view - they are identical in their functionality. -module(my_first_controller). -compile(export_all). my_function(_Req) -&gt; {ok, []}. The example above will then render the view named 'app_main.dtl' Options can be specified as follows: - view - Specifies if another view should be rendered instead of default one - headers - Custom headers","ref":"nova_basic_handler.html#handle_ok/3"},{"type":"function","title":"nova_basic_handler.handle_redirect/3","doc":"Handles redirects. This will return a 302-status code with a location given by the user. Something like {redirect, &quot;/login&quot;} will send a 302 with location set to &quot;/login&quot;","ref":"nova_basic_handler.html#handle_redirect/3"},{"type":"function","title":"nova_basic_handler.handle_sendfile/3","doc":"Handles sendfile.","ref":"nova_basic_handler.html#handle_sendfile/3"},{"type":"function","title":"nova_basic_handler.handle_status/3","doc":"Handler for returning http status codes. There's three different ways one can return status code. The most basic case is {status, Status} where Status is the code that should be returned. If there's a need for additional headers to be sent along with the http code one can specify a third argument that is a map with header-fields. One can also send in a body as a fourth argument in the tuple. It can either be a binary or a map. If it's a map it will be considered a JSON-structure and encoded.","ref":"nova_basic_handler.html#handle_status/3"},{"type":"function","title":"nova_basic_handler.handle_view/3","doc":"Handler for regular views and uses the ok-handler. For more info see handle_ok/3.","ref":"nova_basic_handler.html#handle_view/3"},{"type":"function","title":"nova_basic_handler.handle_websocket/3","doc":"Handles upgrading to websocket","ref":"nova_basic_handler.html#handle_websocket/3"},{"type":"function","title":"nova_basic_handler.handle_ws/2","doc":"Handles basic websocket operations. This is a special handler in regards to arguments. Handlers for websocket only takes two arguments; What the controller returned and the state. And the handler should return what cowboy expects. Example of a valid return value is {reply, Frame, State}","ref":"nova_basic_handler.html#handle_ws/2"},{"type":"type","title":"nova_basic_handler.erlydtl_vars/0","doc":null,"ref":"nova_basic_handler.html#t:erlydtl_vars/0"},{"type":"type","title":"nova_basic_handler.mod_fun/0","doc":null,"ref":"nova_basic_handler.html#t:mod_fun/0"},{"type":"module","title":"nova_correlation_plugin","doc":"Plugin Configuration To not break backwards compatibility in a minor release, some behavior is behind configuration items. Request Correlation Header Name Set request_correlation_header in the plugin config to read the correlation ID from the request headers. Notice: Cowboy request headers are always in lowercase. Default Correlation ID Generation If the header name is not defined or the request lacks a correlation ID header, then the plugin generates a v4 UUID automatically. Logger Metadata Key Override Use logger_metadata_key to customize the correlation ID key in OTP logger process metadata. By default it is set to &lt;&lt;&quot;correlation-id&quot;&gt;&gt; . Correlation ID in Request Object The plugin defines a field called correlation_id in the request object for controller use if it makes further requests that it want to pass on the correlation id to. Example configuration {plugins, [ {pre_request, nova_correlation_plugin, #{ request_correlation_header =&gt; &lt;&lt;&quot;x-correlation-id&quot;&gt;&gt;, logger_metadata_key =&gt; correlation_id }} ]}","ref":"nova_correlation_plugin.html"},{"type":"function","title":"nova_correlation_plugin.plugin_info/0","doc":null,"ref":"nova_correlation_plugin.html#plugin_info/0"},{"type":"function","title":"nova_correlation_plugin.post_request/2","doc":null,"ref":"nova_correlation_plugin.html#post_request/2"},{"type":"function","title":"nova_correlation_plugin.pre_request/2","doc":"Pre-request callback to either pick up correlation id from request headers or generate a new uuid correlation id.","ref":"nova_correlation_plugin.html#pre_request/2"},{"type":"module","title":"nova_cors_plugin","doc":null,"ref":"nova_cors_plugin.html"},{"type":"function","title":"nova_cors_plugin.plugin_info/0","doc":"nova_plugin callback. Returns information about the plugin.","ref":"nova_cors_plugin.html#plugin_info/0"},{"type":"function","title":"nova_cors_plugin.post_request/2","doc":"Post-request callback","ref":"nova_cors_plugin.html#post_request/2"},{"type":"function","title":"nova_cors_plugin.pre_request/2","doc":"Pre-request callback","ref":"nova_cors_plugin.html#pre_request/2"},{"type":"module","title":"nova_erlydtl_inventory","doc":null,"ref":"nova_erlydtl_inventory.html"},{"type":"function","title":"nova_erlydtl_inventory.inventory/1","doc":null,"ref":"nova_erlydtl_inventory.html#inventory/1"},{"type":"function","title":"nova_erlydtl_inventory.url/2","doc":null,"ref":"nova_erlydtl_inventory.html#url/2"},{"type":"function","title":"nova_erlydtl_inventory.version/0","doc":null,"ref":"nova_erlydtl_inventory.html#version/0"},{"type":"module","title":"nova_error_controller","doc":null,"ref":"nova_error_controller.html"},{"type":"function","title":"nova_error_controller.not_found/1","doc":null,"ref":"nova_error_controller.html#not_found/1"},{"type":"function","title":"nova_error_controller.server_error/1","doc":null,"ref":"nova_error_controller.html#server_error/1"},{"type":"function","title":"nova_error_controller.status_code/1","doc":null,"ref":"nova_error_controller.html#status_code/1"},{"type":"behaviour","title":"nova_handler","doc":null,"ref":"nova_handler.html"},{"type":"function","title":"nova_handler.execute/2","doc":null,"ref":"nova_handler.html#execute/2"},{"type":"callback","title":"nova_handler.init/2","doc":null,"ref":"nova_handler.html#c:init/2"},{"type":"function","title":"nova_handler.terminate/3","doc":null,"ref":"nova_handler.html#terminate/3"},{"type":"callback","title":"nova_handler.terminate/3","doc":null,"ref":"nova_handler.html#c:terminate/3"},{"type":"module","title":"nova_handlers","doc":"This module is responsible for all the different return types a controller have. Nova is constructed in such way that it's really easy to extend it by using handlers . A handler is basically a module consisting of a function of arity 4. We will show an example of this. If you implement the following module: -module(my_handler). -export([init/0, handle_console]). init() -&gt; nova_handlers:register_handler(console, {my_handler, handle_console}). handle_console({console, Format, Args}, {Module, Function}, State) -&gt; io:format(&quot;~n=====================~n&quot;, []). io:format(&quot;~p:~p was called.~n&quot;, []), io:format(&quot;State: ~p~n&quot;, [State]), io:format(Format, Args), io:format(&quot;~n=====================~n&quot;, []), {ok, 200, #{}, EmptyBinary}. The init/0 should be invoked from your applications supervisor and will register the module my_handler as handler of the return type {console, Format, Args}. This means that you can return this tuple in a controller which invokes my_handler:handle_console/4. A handler can return two different types {ok, StatusCode, Headers, Body} - This will return a proper reply to the requester. {error, Reason} - This will render a 500 page to the user.","ref":"nova_handlers.html"},{"type":"function","title":"nova_handlers.get_handler/1","doc":"Fetches the handler identified with 'Handle' and returns the callback function for it.","ref":"nova_handlers.html#get_handler/1"},{"type":"function","title":"nova_handlers.register_handler/2","doc":"Registers a new handler. This can then be used in a nova controller by returning a tuple where the first element is the name of the handler.","ref":"nova_handlers.html#register_handler/2"},{"type":"function","title":"nova_handlers.start_link/0","doc":null,"ref":"nova_handlers.html#start_link/0"},{"type":"function","title":"nova_handlers.unregister_handler/1","doc":"Unregisters a handler and makes it unavailable for all controllers.","ref":"nova_handlers.html#unregister_handler/1"},{"type":"type","title":"nova_handlers.handler_callback/0","doc":null,"ref":"nova_handlers.html#t:handler_callback/0"},{"type":"type","title":"nova_handlers.handler_return/0","doc":null,"ref":"nova_handlers.html#t:handler_return/0"},{"type":"behaviour","title":"nova_plugin","doc":"Plugins can be run at two different times; either in the beginning or at the end of a request. They can modify both the actual request or the nova-state. A plugin is implemented with the nova_plugin behaviour and needs to implement three different functions: pre_request/2, post_request/2 and plugin_info/0. A plugin can return either {ok, NewState}, {break, NewState}, {stop, NewState}, {error, Reason}. {ok, NewState} will continue the normal execution with the NewState. {break, NewState} breaks the execution of the current plugin-chain. This means that if a pre_request-plugin returns the break-statement the rest of the plugins in that chain will be skipped. {stop, NewState} stops the execution. The plugin is responsible in this case for returning a proper response to the client. {error, Reason} will stop the execution and call the nova_error plugin, resulting in a 500 response back to the user. If debug mode is enabled the reason will be returned in the 500-response.","ref":"nova_plugin.html"},{"type":"callback","title":"nova_plugin.plugin_info/0","doc":null,"ref":"nova_plugin.html#c:plugin_info/0"},{"type":"callback","title":"nova_plugin.post_request/2","doc":null,"ref":"nova_plugin.html#c:post_request/2"},{"type":"callback","title":"nova_plugin.pre_request/2","doc":null,"ref":"nova_plugin.html#c:pre_request/2"},{"type":"type","title":"nova_plugin.request_type/0","doc":null,"ref":"nova_plugin.html#t:request_type/0"},{"type":"module","title":"nova_plugin_handler","doc":null,"ref":"nova_plugin_handler.html"},{"type":"function","title":"nova_plugin_handler.execute/2","doc":null,"ref":"nova_plugin_handler.html#execute/2"},{"type":"module","title":"nova_pubsub","doc":"Pubsub system for Nova. It uses the pg/pg2 module. Pubsub subsystem is started with Nova and does not need any additional configuration. It uses the pg/pg2 module depending on the version of OTP. It provides a simple way of distributing messages to a large set of receivers and exposes a simple set of functions for doing that. A simple example of how to use pubsub in a ping/pong inspired game engine: -module(test_module). -export([player1/0, player2/0, start_game/0]). player1() -&gt; spawn(fun() -&gt; nova_pubsub:join(game_of_pong), game_loop(1, &quot;pong&quot;, &quot;ping&quot;). player2() -&gt; spawn(fun() -&gt; nova_pubsub:join(game_of_pong), game_loop(2, &quot;ping&quot;, &quot;pong&quot;). game_loop(Player, ExpectedMessage, Smash) -&gt; receive ExpectedMessage -&gt; io:format(&quot;Player ~d received ~s and returning ~s~n&quot;, [Player, ExpectedMessage, Smash]), nova_pubsub:broadcast(game_of_pong, &quot;match1&quot;, Smash), game_loop(Player, ExpectedMessage, Smash); _ -&gt; game_loop(Player, ExpectedMessage, Smash) end.","ref":"nova_pubsub.html"},{"type":"function","title":"nova_pubsub.broadcast/3","doc":"Broadcasts a message to all members of a channel. Topic is specified to differentiate messages within the same channel.","ref":"nova_pubsub.html#broadcast/3"},{"type":"function","title":"nova_pubsub.get_local_members/1","doc":"Works the same way as get_members/1 but returns only members on the same node.","ref":"nova_pubsub.html#get_local_members/1"},{"type":"function","title":"nova_pubsub.get_members/1","doc":"Returns all members for a given channel","ref":"nova_pubsub.html#get_members/1"},{"type":"function","title":"nova_pubsub.join/1","doc":"Joining a channel with the calling process. Always returns ok","ref":"nova_pubsub.html#join/1"},{"type":"function","title":"nova_pubsub.join/2","doc":"Same as join/1 but with a specified process.","ref":"nova_pubsub.html#join/2"},{"type":"function","title":"nova_pubsub.leave/1","doc":"Leaves a channnel. Will return ok on success and not_joined if the calling process were not part of the channel.","ref":"nova_pubsub.html#leave/1"},{"type":"function","title":"nova_pubsub.leave/2","doc":"Same as leave/1 but with a specified process.","ref":"nova_pubsub.html#leave/2"},{"type":"function","title":"nova_pubsub.local_broadcast/3","doc":"Works in the same way as broadcast/3 but only for members in the same node.","ref":"nova_pubsub.html#local_broadcast/3"},{"type":"function","title":"nova_pubsub.start/0","doc":null,"ref":"nova_pubsub.html#start/0"},{"type":"module","title":"nova_request_plugin","doc":null,"ref":"nova_request_plugin.html"},{"type":"function","title":"nova_request_plugin.plugin_info/0","doc":"nova_plugin callback. Returns information about the plugin.","ref":"nova_request_plugin.html#plugin_info/0"},{"type":"function","title":"nova_request_plugin.post_request/2","doc":"Post-request callback","ref":"nova_request_plugin.html#post_request/2"},{"type":"function","title":"nova_request_plugin.pre_request/2","doc":"Pre-request callback","ref":"nova_request_plugin.html#pre_request/2"},{"type":"behaviour","title":"nova_router","doc":null,"ref":"nova_router.html"},{"type":"function","title":"nova_router.compile/1","doc":null,"ref":"nova_router.html#compile/1"},{"type":"function","title":"nova_router.compiled_apps/0","doc":null,"ref":"nova_router.html#compiled_apps/0"},{"type":"function","title":"nova_router.execute/2","doc":null,"ref":"nova_router.html#execute/2"},{"type":"function","title":"nova_router.lookup_url/1","doc":null,"ref":"nova_router.html#lookup_url/1"},{"type":"function","title":"nova_router.lookup_url/2","doc":null,"ref":"nova_router.html#lookup_url/2"},{"type":"function","title":"nova_router.lookup_url/3","doc":null,"ref":"nova_router.html#lookup_url/3"},{"type":"function","title":"nova_router.render_status_page/2","doc":null,"ref":"nova_router.html#render_status_page/2"},{"type":"function","title":"nova_router.render_status_page/3","doc":null,"ref":"nova_router.html#render_status_page/3"},{"type":"function","title":"nova_router.render_status_page/5","doc":null,"ref":"nova_router.html#render_status_page/5"},{"type":"function","title":"nova_router.routes/1","doc":null,"ref":"nova_router.html#routes/1"},{"type":"callback","title":"nova_router.routes/1","doc":null,"ref":"nova_router.html#c:routes/1"},{"type":"type","title":"nova_router.bindings/0","doc":null,"ref":"nova_router.html#t:bindings/0"},{"type":"type","title":"nova_router.host_tree/0","doc":null,"ref":"nova_router.html#t:host_tree/0"},{"type":"type","title":"nova_router.options/0","doc":null,"ref":"nova_router.html#t:options/0"},{"type":"type","title":"nova_router.routing_tree/0","doc":null,"ref":"nova_router.html#t:routing_tree/0"},{"type":"module","title":"nova_security_handler","doc":null,"ref":"nova_security_handler.html"},{"type":"function","title":"nova_security_handler.execute/2","doc":null,"ref":"nova_security_handler.html#execute/2"},{"type":"behaviour","title":"nova_session","doc":"All kind of operations on sessions is handled by the nova_session-module. The module also presents a behaviour that can be used to create customized backends for the session-data.","ref":"nova_session.html"},{"type":"function","title":"nova_session.delete/1","doc":null,"ref":"nova_session.html#delete/1"},{"type":"function","title":"nova_session.delete/2","doc":null,"ref":"nova_session.html#delete/2"},{"type":"callback","title":"nova_session.delete_value/1","doc":null,"ref":"nova_session.html#c:delete_value/1"},{"type":"callback","title":"nova_session.delete_value/2","doc":null,"ref":"nova_session.html#c:delete_value/2"},{"type":"function","title":"nova_session.generate_session_id/0","doc":null,"ref":"nova_session.html#generate_session_id/0"},{"type":"function","title":"nova_session.get/2","doc":null,"ref":"nova_session.html#get/2"},{"type":"callback","title":"nova_session.get_value/2","doc":null,"ref":"nova_session.html#c:get_value/2"},{"type":"function","title":"nova_session.set/3","doc":null,"ref":"nova_session.html#set/3"},{"type":"callback","title":"nova_session.set_value/3","doc":null,"ref":"nova_session.html#c:set_value/3"},{"type":"module","title":"nova_session_ets","doc":null,"ref":"nova_session_ets.html"},{"type":"function","title":"nova_session_ets.delete_value/1","doc":null,"ref":"nova_session_ets.html#delete_value/1"},{"type":"function","title":"nova_session_ets.delete_value/2","doc":null,"ref":"nova_session_ets.html#delete_value/2"},{"type":"function","title":"nova_session_ets.get_value/2","doc":null,"ref":"nova_session_ets.html#get_value/2"},{"type":"function","title":"nova_session_ets.set_value/3","doc":null,"ref":"nova_session_ets.html#set_value/3"},{"type":"function","title":"nova_session_ets.start_link/0","doc":"Starts the server","ref":"nova_session_ets.html#start_link/0"},{"type":"module","title":"nova_stream_h","doc":null,"ref":"nova_stream_h.html"},{"type":"function","title":"nova_stream_h.data/4","doc":null,"ref":"nova_stream_h.html#data/4"},{"type":"function","title":"nova_stream_h.early_error/5","doc":null,"ref":"nova_stream_h.html#early_error/5"},{"type":"function","title":"nova_stream_h.info/3","doc":null,"ref":"nova_stream_h.html#info/3"},{"type":"function","title":"nova_stream_h.init/3","doc":null,"ref":"nova_stream_h.html#init/3"},{"type":"function","title":"nova_stream_h.terminate/3","doc":null,"ref":"nova_stream_h.html#terminate/3"},{"type":"type","title":"nova_stream_h.state/0","doc":null,"ref":"nova_stream_h.html#t:state/0"},{"type":"module","title":"nova_sup","doc":"Nova supervisor","ref":"nova_sup.html"},{"type":"function","title":"nova_sup.start_link/0","doc":"Starts the supervisor","ref":"nova_sup.html#start_link/0"},{"type":"module","title":"nova_watcher","doc":null,"ref":"nova_watcher.html"},{"type":"function","title":"nova_watcher.async_cast/1","doc":null,"ref":"nova_watcher.html#async_cast/1"},{"type":"function","title":"nova_watcher.async_cast/2","doc":null,"ref":"nova_watcher.html#async_cast/2"},{"type":"function","title":"nova_watcher.async_cast/3","doc":null,"ref":"nova_watcher.html#async_cast/3"},{"type":"function","title":"nova_watcher.async_cast/4","doc":null,"ref":"nova_watcher.html#async_cast/4"},{"type":"function","title":"nova_watcher.start_link/0","doc":"Starts the server","ref":"nova_watcher.html#start_link/0"},{"type":"function","title":"nova_watcher.stop/0","doc":null,"ref":"nova_watcher.html#stop/0"},{"type":"behaviour","title":"nova_websocket","doc":null,"ref":"nova_websocket.html"},{"type":"callback","title":"nova_websocket.init/1","doc":null,"ref":"nova_websocket.html#c:init/1"},{"type":"callback","title":"nova_websocket.terminate/3","doc":null,"ref":"nova_websocket.html#c:terminate/3"},{"type":"callback","title":"nova_websocket.websocket_handle/2","doc":null,"ref":"nova_websocket.html#c:websocket_handle/2"},{"type":"callback","title":"nova_websocket.websocket_info/2","doc":null,"ref":"nova_websocket.html#c:websocket_info/2"},{"type":"callback","title":"nova_websocket.websocket_init/1","doc":null,"ref":"nova_websocket.html#c:websocket_init/1"},{"type":"type","title":"nova_websocket.call_result/0","doc":null,"ref":"nova_websocket.html#t:call_result/0"},{"type":"type","title":"nova_websocket.in_frame/0","doc":null,"ref":"nova_websocket.html#t:in_frame/0"},{"type":"module","title":"nova_ws_handler","doc":"Callback controller for handling websockets","ref":"nova_ws_handler.html"},{"type":"function","title":"nova_ws_handler.init/2","doc":null,"ref":"nova_ws_handler.html#init/2"},{"type":"function","title":"nova_ws_handler.terminate/3","doc":null,"ref":"nova_ws_handler.html#terminate/3"},{"type":"function","title":"nova_ws_handler.websocket_handle/2","doc":null,"ref":"nova_ws_handler.html#websocket_handle/2"},{"type":"function","title":"nova_ws_handler.websocket_info/2","doc":null,"ref":"nova_ws_handler.html#websocket_info/2"},{"type":"function","title":"nova_ws_handler.websocket_init/1","doc":null,"ref":"nova_ws_handler.html#websocket_init/1"},{"type":"type","title":"nova_ws_handler.nova_ws_state/0","doc":null,"ref":"nova_ws_handler.html#t:nova_ws_state/0"},{"type":"extras","title":"Quick start","doc":"# Quick start","ref":"quick-start.html"},{"type":"extras","title":"Start your first project - Quick start","doc":"Nova provides a plugin to make working with the framework a lot easier. One can install it by either using\nan automated installation or include it manually in the global *rebar.config* file.\n\n> ##","ref":"quick-start.html#start-your-first-project"},{"type":"extras","title":"Note :bangbang: - Quick start","doc":">\n> If you require help installing Erlang and/or rebar3 please check [https://adoptingerlang.org/docs/development/setup/](https://adoptingerlang.org/docs/development/setup/)\n\n#","ref":"quick-start.html#note-bangbang"},{"type":"extras","title":"Automated installation - Quick start","doc":"*Via Curl*\n\n```bash\nsh -c \"$(curl -fsSL https://raw.githubusercontent.com/novaframework/rebar3_nova/master/install.sh)\"\n```\n\n*Via wget*\n```bash\nsh -c \"$(wget -O- https://raw.githubusercontent.com/novaframework/rebar3_nova/master/install.sh)\"\n```\n\n#","ref":"quick-start.html#automated-installation"},{"type":"extras","title":"Manual installation - Quick start","doc":"Open your `rebar.config` file that should reside in `~/.config/rebar3/rebar.config*`. If the file does not exist you\ncan just create it. Locate the `plugins` section of the file and include the nova plugin. The result should look something like\nthe following:\n\n```\n{plugins,[{rebar3_nova,{git,\"https://github.com/novaframework/rebar3_nova.git\",\n                            {branch,\"master\"}}}]}.\n```\n\n\n#","ref":"quick-start.html#manual-installation"},{"type":"extras","title":"Creating the skeleton - Quick start","doc":"After the installation of the Nova-plugin is done use rebar3 to generate a new project.\n\n```bash\nrebar3 new nova my_first_nova\n```\n\n```\n$ rebar3 new nova my_first_app\n===> Writing my_first_nova/config/dev_sys.config.src\n===> Writing my_first_nova/config/prod_sys.config.src\n===> Writing my_first_nova/src/my_first_nova.app.src\n===> Writing my_first_nova/src/my_first_nova_app.erl\n===> Writing my_first_nova/src/my_first_nova_sup.erl\n===> Writing my_first_nova/src/my_first_nova_router.erl\n===> Writing my_first_nova/src/controllers/my_first_nova_main_controller.erl\n===> Writing my_first_nova/rebar.config\n===> Writing my_first_nova/config/vm.args.src\n===> Writing my_first_nova/src/views/my_first_nova_main.dtl\n```\n\nNow the skeleton have been created and you should be able to start it. Go into the newly created directory and run the `serve` command.\n\n> ##","ref":"quick-start.html#creating-the-skeleton"},{"type":"extras","title":"Note :bangbang: - Quick start","doc":">\n> For the auto-compile/reload to work you need [inotify](https://github.com/massemanet/inotify) to be installed.\n\n```\n$ cd my_first_app\n$ rebar3 nova serve\n===> Verifying dependencies...\n===> Compiling my_first_app\nErlang/OTP 20 [erts-9.3] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:0] [hipe] [kernel-poll:false]\n...\na lot of progress-reports\n...\n===> Booted my_first_app\n...\n```\n\nIf you take a look at [http://localhost:8080](http://localhost:8080) you should be greeted by a Nova-page.","ref":"quick-start.html#note-bangbang"},{"type":"extras","title":"configuration","doc":"There's a lot of parameters that can be configured in Nova. This document will try to explain them all.\n\n# Cowboy configuration\n\nNova uses Cowboy as the webserver. Cowboy is a very flexible webserver and Nova tries to expose as much of this flexibility as possible. This means that you can configure Cowboy in a lot of different ways. The configuration is done in the `nova`-application under `cowboy_configuration`-key in your *sys.config*.\n\n| Key | Description | Value | Default |\n|-----|-------------|-------|---------|\n| `stream_handlers` | Stream handlers are used to handle streaming requests. You can configure multiple stream handlers. Read more in the subsection *Stream handlers* | `list()` | `[nova_stream_h, cowboy_compress_h, cowboy_stream_h]` |\n| `options` | Cowboy options. Read more in the subsection *Cowboy options* | `map()` | `#{compress => true}` |\n| `ip` | IP to bind to | `tuple` | `{0, 0, 0, 0}` |\n| `port` | Port to bind to | `integer()` | `8080` |\n| `use_ssl` | If SSL should be used | `boolean()` | `false` |\n| `ssl_port` | Port to bind to when using SSL | `integer()` | `8443` |\n| `ca_cert` | Path to CA-cert | `string()` | `undefined` |\n| `cert` | Path to cert | `string()` | `undefined` |\n\n\n# Nova specific configurations\n\nFollowing parameters should be defined under the `nova`-key in your *sys.config*.\n\n| Key | Description | Value |\n|-----|-------------|-------|\n| `use_persistent_term` | Use `persistent_term` module to store routing tree | `boolean()` |\n| `use_stacktrace` | If Nova should include stacktrace in error-pages | `boolean()` |\n| `render_error_pages` | If Nova should render error-pages for HTML-request | `boolean()` |\n| `use_sessions` | Turn off/on support for sessions | `boolean()` |\n| `session_manager` | Specifify a module to use as the session manager. Defaults to `nova_session_ets` | `atom()` |\n| `use_strict_routing`    | If the routing module should work under the strict mode. Using strict mode will cause errors if non-deterministic paths are detected. This is a beta-function so use with caution. | `boolean()` |\n| `bootstrap_application` | Define which application to bootstrap with Nova. This should be the name of your application. | `atom()` |\n| `cowboy_configuration` | If you need some additional configuration done to Cowboy this is the place. Check `nova_sup` module to learn which keys that can be defined. | `map()` |\n\n# Application parameters\n\nThese parameters can be specified in your *main* application (Eg the one you've specified in the `bootstrap`-section).\n\n| Key | Description | Value |\n|-----|-------------|-------|\n| `json_lib` | JSON lib to use. Read more in the subsection *Configure json lib* | `atom()` |\n| `watchers` | Watchers are external programs that will run together with Nova. Watchers are defined as list of tuples where the tuples is in format `{Command, ArgumentList}` (Like `[{my_app, \"npm\", [\"run\", \"watch\"], #{workdir => \"priv/assets/js/my-app\"}}]`) | `[{string(), string()}] | [{atom(), string(), map()}] | [{atom(), string(), list(), map()}]` |","ref":"configuration.html"},{"type":"extras","title":"Configure json_lib - configuration","doc":"One can configure which json library to use for encoding/decoding json structures. The module defined for this should expose two different functions:\n\n`encode(Structure) -> binary() | iolist()`\n\n`decode(JsonString) -> {ok, Structure}`\n\n\n# Handling errors in Nova\n\nNova will by default render a error page if an error occurs. This page will be rendered using the `nova_error`-template. This template can be overridden by defining a template with the same name in your application.\nBy defauly Nova outputs a lot of information, including the stacktrace. This might not be a good approach in production. To turn off stacktraces in production you can add the following to your *sys.config*:\n\n```erlang\n{nova, [{render_error_pages, false}]}\n```\n\nThis will exclude stacktrace from the error page.\n\n*Note* Nova is aware about which `accept`-headers the request is sent with and will respond with the correct content-type. If the request is sent with `application/json` Nova will respond with a JSON-structure instead of a HTML-page.","ref":"configuration.html#configure-json_lib"},{"type":"extras","title":"Routing","doc":"# Routing\n\nEach nova application have their own routes file. This file contains information about all the routes existing for this application.","ref":"routing.html"},{"type":"extras","title":"Basic components - Routing","doc":"A simple route file could look something like this:\n\n```erlang\n-module(my_app_router).\n\n-export([routes/1]).\n\nroutes(_Environment) ->\n  [#{prefix => \"/admin\",\n    security => false,\n    routes => [\n      {\"/\", {my_controller, main}, #{methods => [get]}}\n    ]\n  }].\n```\n\nThis will create a path for `/admin` which, when a user enters will call `my_controller:main/1`. The `_Environment` variable that is consumed by the `routes` function will have the value that `nova:get_environment/0` returns. The *environment* variable is an important thing cause it enables the devlopers to define different routes for different environments. To change the running environment edit the `sys.config` file to include an `{environment, Env}` tuple under the `nova` application where `Env` can be any erlang-term.\n\n#","ref":"routing.html#basic-components"},{"type":"extras","title":"The routing object - Routing","doc":"The routing object consists of three or four fields.\n\n#","ref":"routing.html#the-routing-object"},{"type":"extras","title":"HTTP(S) Routing ### - Routing","doc":"```\n{Route :: list(), {Controller :: atom(), Function :: atom()}, Options :: map()}\n```\n\nAs you saw in the initial example in the [Basic components](#basic-components) section, we defined a route for the root path `/`.\n\n#","ref":"routing.html#http-s-routing"},{"type":"extras","title":"Websocket routing ### - Routing","doc":"```\n{Route :: list(), Controller :: atom(), Options :: map()}\n```\n\n> ##","ref":"routing.html#websocket-routing"},{"type":"extras","title":"Important {: .tip} - Routing","doc":">\n> One needs to define `protocol => ws` in the options-map in order to enable websocket communications.","ref":"routing.html#important-tip"},{"type":"extras","title":"How to create routes - Routing","doc":"A route consists of four different components:\n\n* `Path` - This is the actual path to the endpoint. Eg `\"/admin\"`\n* `Method` - What method you want to support for this endpoint (get, post, update, delete). If you want to support all methods you can use the `'_'`-atom.\n* `Controller` - What erlang module should be called on when the path gets called.\n* `Function` - Which function in the `Controller` will be called when path gets called.","ref":"routing.html#how-to-create-routes"},{"type":"extras","title":"Using prefix - Routing","doc":"You can group paths where you prefix them with a path. This is especially useful when having several different nova applications running. A very common example would be if you had an administration interface. Then the prefix would be `\"/admin\"`. Another example is versioned APIs.\n\nPrefix is defined at top level of a route-entry which can be seen in the [Basic components](#basic-components) section of this chapter.","ref":"routing.html#using-prefix"},{"type":"extras","title":"Secure routing - Routing","doc":"You can secure routes by providing a module and function to the `security` directive in the route entry. Here's a simple example of this:\n\n```erlang\n#{prefix => \"/admin\",\n  type => html,\n  security => {security_controller, do_security},\n  routes => [\n    {\"/\", {my_controller, main}, #{methods => [get]}}\n  ]\n}\n```\n\nThis will cause nova to call `security_controller:do_security/1` before calling the actual controller for all routes defined in the above route entry.\nThe security function should return a boolean (If the user can proceed or not).\n\n\nAn example of a security function:\n\n\n```erlang\ndo_security(Req) ->\n    maps:get(host, Req) == \"my_domain.com\".\n```\n\nThis will cause nova to return a `401` status code for all requests not coming from `my_domain.com`","ref":"routing.html#secure-routing"},{"type":"extras","title":"Using plugins local to a set of endpoints - Routing","doc":"It's possible to configure a small set of endpoints with a specific plugin. This is done by adding a `plugins` key to the route entry. The value of this key should be a list of plugins to use for this route entry.\n\n```erlang\n#{prefix => \"/admin\",\n  plugins => [\n    {pre_request, nova_json_schemas, #{render_errors => true}}\n  ],\n  routes => [\n    {\"/\", {my_controller, main}, #{methods => [get]}}\n  ]\n}\n```\n\nIn the example above we have enabled the *pre-request*-plugin `nova_json_schemas` for all routes under the `/admin` prefix. This will cause all requests to be validated against the JSON schema defined in the `nova_json_schemas` plugin.\nYou can also include *post-request*-plugins in the same way.","ref":"routing.html#using-plugins-local-to-a-set-of-endpoints"},{"type":"extras","title":"Controllers","doc":"# Controllers\n\nControllers are central in how Nova works. They are in charge of handling all user-implemented logic for a request.\nControllers are located in the `/src/controllers/` directory of your Nova application. A controller is basically a regular Erlang module that exposes functions you've provided in the routing file.\n\n![Request life-cycle](assets/controller_flow.png \"Request life-cycle\")","ref":"controllers.html"},{"type":"extras","title":"Handlers - Controllers","doc":"Handlers are modules that interprets the resulting output from a controller and sends it to the requester. Handlers are identified by the first atom in the return of a controller, eg `{json, #{status => \"ok\"}}` calls the `json` handler. You can read about the handlers below and what their functions are.\n\n#","ref":"controllers.html#handlers"},{"type":"extras","title":"JSON structures - Controllers","doc":"##","ref":"controllers.html#json-structures"},{"type":"extras","title":"Simple interface - Controllers","doc":"*Keyword*: `json`\n\n*Spec*: `{json, Structure :: map()}`\n\n*Example*: `{json, #{status => \"ok\"}}.`\n\nConverts the map (Second element in the resulting tuple) and sends it to the requester with *HTTP-status code 200*.\n\n##","ref":"controllers.html#simple-interface"},{"type":"extras","title":"Advanced interface - Controllers","doc":"*Keyword*: `json`\n\n*Spec*: `{json, StatusCode :: integer(), Headers :: map(), JSON :: map()}`\n\n*Example*: `{json, 201, #{\"x-correlation-id\", \"EX123\"}, #{some_response => true}}`\n\nSame as the simple interface but with two additional elements for specifying HTTP-status code and additional headers.\n\n#","ref":"controllers.html#advanced-interface"},{"type":"extras","title":"HTML templates (Using Erlydtl) - Controllers","doc":"*Nova* renders templates using ErlyDTL ([https://github.com/erlydtl/erlydtl](https://github.com/erlydtl/erlydtl) which uses the *django template language* to express logic. To get a better overview for the functionality that comes with dtl check their [documentation page](https://django.readthedocs.io/en/1.6.x/ref/templates/builtins.html)\n\n##","ref":"controllers.html#html-templates-using-erlydtl"},{"type":"extras","title":"Simple interface - Controllers","doc":"*Keyword*: `view`\n\n*Spec*: `{view, Variables :: map() | [{Key :: atom() | binary() | string(), Value :: any()}]}`\n\n*Example*: `{view, #{my_var => \"123\"}}`\n\nRenders the corresponding view with the variables attached. If a controller is named `my_simple_controller.erl` the view is named `my_simple_view.dtl`.\n\n##","ref":"controllers.html#simple-interface"},{"type":"extras","title":"Advanced interface - Controllers","doc":"*Keyword*: `view`\n\n*Spec*: `{view, Variables :: map() | [{Key :: atom() | binary() | string(), Value :: any()}], Options :: map()}`\n\n*Example*: `{view, #{my_var => \"123\"}, #{view => my_view_mod}}`\n\nSame as the simple interface but where you can define some options. Currently the only option for this interface is *view* which enables the user to specify a view other than the corresponding one based on controllers name. In the example above the dtl-file `my_view_mod.dtl` would be rendered.\n\n#","ref":"controllers.html#advanced-interface"},{"type":"extras","title":"HTTP-status codes - Controllers","doc":"##","ref":"controllers.html#http-status-codes"},{"type":"extras","title":"Simple interface - Controllers","doc":"*Keyword*: `status`\n\n*Spec*: `{status, StatusCode :: integer()}`\n\n*Example*: `{status, 200}`\n\nReturns a HTTP-code to the requester with an empty body.\n\n##","ref":"controllers.html#simple-interface"},{"type":"extras","title":"Medium interface - Controllers","doc":"*Keyword*: `status`\n\n*Spec*: `{status, StatusCode :: integer(), ExtraHeaders :: map()}`\n\n*Example*: `{status, 200, #{\"content-type\" => \"application/json\"}}`\n\nSame as the simple interface but with an additional field for specifying additional headers.\n\n##","ref":"controllers.html#medium-interface"},{"type":"extras","title":"Advanced interface - Controllers","doc":"*Keyword*: `status`\n\n*Spec*: `{status, Status :: integer(), ExtraHeaders :: map(), Body :: binary()}`\n\n*Example*: `{status, 200, #{\"content-type\" => \"text/plain\"}, \"A plain text\"}`\n\nSame as the medium interface but with an additional field for specifying a body.\n\n#","ref":"controllers.html#advanced-interface"},{"type":"extras","title":"File transfers (Using cowboys sendfile functionality) - Controllers","doc":"*Keyword*: `sendfile`\n\n*Spec*: `{sendfile, StatusCode :: integer(), Headers :: map(), {Offset :: integer(), Length :: integer(), Path :: list()}, Mime :: binary()}`\n\n*Example*: `{sendfile, 200, #{}, {0, 12345, \"path/to/logo.png\"}, \"image/png\"}`\n\nSends a file using sendfile. This uses cowboys sendfile functionality and more information about it can be found in the [cowboy manual on sendfile](https://ninenines.eu/docs/en/cowboy/2.9/guide/resp/#_sending_files)\n\n#","ref":"controllers.html#file-transfers-using-cowboys-sendfile-functionality"},{"type":"extras","title":"Redirecting user - Controllers","doc":"*Keyword*: `redirect`\n\n*Spec*: `{redirect, Route :: list() | binary()}`\n\n*Example*: `{redirect, \"/my/other/path}`\n\nSends a temporary redirect (HTTP status code 302) for the specified path to requester.","ref":"controllers.html#redirecting-user"},{"type":"extras","title":"Fallback controllers - Controllers","doc":"[Phoenix](https://www.phoenixframework.org) have a really useful feature which they call [action_fallback]( https://hexdocs.pm/phoenix/Phoenix.Controller.html#action_fallback/1). We thought it would be a good addition to Nova to include something similar and therefore the `fallback_controller` was introduced. If a controller returns an invalid/unhandled result the fallback controller gets invoked and can take action on the payload. It's good for separating error-handling from the controllers. A fallback controller is set by setting the `fallback_controller` attribute with the module name of the fallback controller.\n\nThe following example shows how a controller defines a fallback\n\n```\n-module(my_main_controller).\n-export([\n    error_example/1\n]).\n-fallback_controller(my_fallback_controller).\n\nerror_example(_Req) ->\n    %% Since {error, ...} is not a valid handler the fallback-controller will be invoked\n    {error, example_error}.\n```\n\nA fallback controller exposes one function `resolve/2` which returns a handler (like for regular controllers) in order to return the response to client. If we take the previous example and try and build a fallback controller for it:\n\n```\n-module(my_fallback_controller).\n-export([\n    resolve/2\n]).\n\nresolve(Req, {error, example_error}) ->\n  {status, 400}.\n```","ref":"controllers.html#fallback-controllers"},{"type":"extras","title":"Plugins - Controllers","doc":"Plugins are part of the Nova core and can be executed both before and after the execution of a controller. They can both terminate a request early (like the *request plugin* does) or transform data into another structure (*json plugin*). Plugins can be defined in two different places; *Global* plugins are defined in the *sys.config* file and will be executed for every incoming request. If a plugin should only be executed for a limited set of endpoints it can be defined in the router file for that specific application (we call there *local plugins*).\n\n#","ref":"controllers.html#plugins"},{"type":"extras","title":"Global plugins - Controllers","doc":"Global plugins are defined in the *sys.config* file and can have two different states: *pre* and *post* controller. They are exectued before or after a controller. Global plugins lives under the `nova` application, `plugins` key. An example of a sys.config file:\n\n```\n{nova, [\n  {plugins, [\n    {pre_request, [\n      {nova_request_plugin, #{decode_json_body => true}}\n    ]},\n    {post_request, [\n    ]}\n  ]}\n]}.\n```\n\nIn order to find the valid options one can call the `plugin_info/0` function of each plugin. Currently there are [four plugins](https://github.com/novaframework/nova/tree/master/src/plugins) shipped with Nova.\n\n\n> ##","ref":"controllers.html#global-plugins"},{"type":"extras","title":"NOTE {: .tip} - Controllers","doc":">\n> If you are creating an application that can be included in another Nova application all of your plugins should be defined in the router-file (Local plugins) in order to avoid being overwritten.\n\n\n#","ref":"controllers.html#note-tip"},{"type":"extras","title":"Local plugins - Controllers","doc":"Local plugins works almost as the global ones but for a limited set of paths. Local plugins are therefore declared in the router-file for each *group* of endpoints. They are declared in the same way as the global ones.\n\nExample:\n```\nroutes(_Env) ->\n  [#{\n    prefix => \"/api/json\",\n    security => false,\n    plugins => [\n      {pre_request, [\n        {nova_request_plugin, #{decode_json_body => true}}\n      ]}\n    ],\n    routes => [\n      {\"/my_json_route\", {my_app_json_controller, json}, #{methods => [get, post]}}\n    ]\n  }].\n```\n\nIt's recommended to use this method of specifying routes if you plan to use it as a component in another *Nova application*.","ref":"controllers.html#local-plugins"},{"type":"extras","title":"Websockets - Controllers","doc":"*Coming soon*\n\n#","ref":"controllers.html#websockets"},{"type":"extras","title":"Callbacks - Controllers","doc":"*Coming soon*","ref":"controllers.html#callbacks"},{"type":"extras","title":"Views","doc":"# Views\n\nThe views in Nova are powered by [erlydtl](https://github.com/erlydtl/erlydtl). They use the Django template language and compile down to Erlang.\n\nPlease read the [erlydtl wiki](https://github.com/erlydtl/erlydtl/wiki) for more information regarding the templates.","ref":"views.html"},{"type":"extras","title":"Handlers","doc":"# Handlers","ref":"handlers.html"},{"type":"extras","title":"Handlers - Handlers","doc":"Handlers are a nifty thing that is called on when the controller returns. For example if the controller returns\n`{json, #{hello => world}}` we would like Nova to create a proper JSON response to the requester. That means setting correct\nheaders, encode the payload and send it out. This is what _handlers_ are for. They are (often short) functions that transforms something like\n`{json, Payload}` to proper output.","ref":"handlers.html#handlers"},{"type":"extras","title":"Plugins","doc":"# Plugins\n\nPlugins are a bit like the handlers except they are run on request. There's currently two different type of plugins; `pre_request` and `post_request`.\nThese can be used to create access logs, insert CORS headers or similar.\n\nPlugins are used to handle things before and/or after a request. They are applied on all requests of a specified protocol.\n\nThis is an example:\n\n```erlang\n-module(correlation_id).\n-behaviour(nova_plugin).\n-export([\n    pre_request/2,\n    post_request/2,\n    plugin_info/0\n  ]).\n\npre_request(Req, NovaState) ->\n    UUID = uuid:uuid_to_string(uuid:get_v4()),\n    {ok, cowboy_req:set_resp_header( >, UUID, Req), NovaState}.\n\npost_request(Req, NovaState) ->\n    {ok, Req, NovaState}.\n\nplugin_info() ->\n    { >,  >,  \">>,\n      >}.\n```\n\nThis plugin injects a UUID into the headers.\n\n\nAdding a plugin\n\nExample:\nA good example of a very useful plugin is the `nova_request_plugin`. When we are developing a HTTP web api using json as the data format, we need the framework to\ndecode our message so that we can process it. To do that we need to add `decode_json_body => true` into the options field in our `sys.config`.\n\n\n**sys.config**\n\n\n ```erlang\n     {nova, [\n         {environment, dev},\n         {cowboy_configuration, #{\n                                  port => 8080\n                                 }},\n         {dev_mode, true},\n         {bootstrap_application, chatapp},\n         {plugins, [\n                    {pre_request, nova_request_plugin, #{parse_bindings => true,\n                                                         decode_json_body => true}}\n                   ]}\n        ]}\n ```\n We have added our plugin in the `plugins` section. As we can see this is a `pre_request` plugin since it processes and decodes the message to json format\n before we can actually use it in our nova application endpoints.\n\nUsage:\n\n**controller**\n\n```erlang\n-module(test_controller).\n-export([increment/1]).\n\nincrement(#{ > := #{ > := Id,  > := Value}})->\n    {json,200,#{},#{ > => Id ,  > => Value,  > => Value+1}}.\n\n```","ref":"plugins.html"},{"type":"extras","title":"Nova plugins - Plugins","doc":"Nova has a couple of plugins for some general purposes.\n\n|Plugin|Description|Code|\n|------|-----------|----|\n|nova_correlation_plugin|This plugin will add a correlation id to header response but also add `#{correlation_id => CorrelationID}` to the request obj that is passed to the controller.|[nova_correlation_plugin](https://github.com/novaframework/nova/blob/master/src/plugins/nova_correlation_plugin.erl)|\n|nova_cors_plugin|This plugin will handle cors and add the cors headers into the request.|[nova_cors_plugin](https://github.com/novaframework/nova/blob/master/src/plugins/nova_cors_plugin.erl)|\n|nova_request_plugin|This plugin will handle incomming data like qs, form urlencoded and json|[nova_request_plugin](https://github.com/novaframework/nova/blob/master/src/plugins/nova_request_plugin.erl)|\n\n\n#","ref":"plugins.html#nova-plugins"},{"type":"extras","title":"Nova correlation - Plugins","doc":"This plugin will generate a uuid v4 and set it as a response header as `X-Correlation-ID` if nothing is configuered.\n\n```erlang\n{pre_request; nova_correlation_plugin, #{request_correlation_header => CorrelationHeader,\n                                         logger_metadata_key => LoggerMetaDataKey}}\n```\n\n|Option|Description|\n|------|-----------|\n|request_correlation_header|This is if you want a different correlation header than the standard `X-Correlation-ID`|\n|logger_metadata_key| This is if you want to have a different metadata key then the standard `correaltion_id`|\n\n#","ref":"plugins.html#nova-correlation"},{"type":"extras","title":"Nova cors - Plugins","doc":"This plugins will make it so that if we get method OPTIONS it will just return back the CORS headers. In this case you don't need a controller to handle it and the plugin stops after this.\nFor other methods it will add the CORS headers to the request.\n\n```erlang\n{pre_request; nova_cors_plugin, #{allow_origins =>  >}}\n```\n\n|Option|Description|\n|------|-----------|\n|allow_origins|Specifies which origins to insert into Access-Control-Allow-Origin|\n\n#","ref":"plugins.html#nova-cors"},{"type":"extras","title":"Nova request - Plugins","doc":"This plugins handle incoming data and can transform them to erlang maps depending on what the options are.\n\n```erlang\n{pre_request; nova_correlation_plugin, #{decode_json_body => true,\n                                         read_urlencoded_body => true,\n                                         parse_qs => true|list}}\n```\n\n\n|Option|Description|Req|\n|------|-----------|----|\n|decode_json_body|If header is application/json it will decode the body.| `Req#{json => Map}`|\n|read_urlencoded_body|If header is application/x-www-form-urlencoded it will decode it.| `Req#{params => Map}`|\n|parse_qs| If the path have qs in it we will get them.|`Req#{parsed_qs => Map or List}`|","ref":"plugins.html#nova-request"},{"type":"extras","title":"Nova Pubsub","doc":"# Nova Pubsub\n\nWith version 0.9.4 we introduced the concept of a pubsub-like mechanism in Nova so that users can build distributed services. Internally it relies on Erlangs `pg2`-module which enables distributed named process groups. The concept is really simple and there's not much depth in the current implementation - it should only be used as a simple message bus. If you need more advanced features please take a look at [RabbitMQ](https://www.rabbitmq.com/) or [MQTT](https://mqtt.org).","ref":"pubsub.html"},{"type":"extras","title":"Basic concepts - Nova Pubsub","doc":"The idea is that a process subscribes to a *topic*. If there's any messages sent to this topic all the *subscribed* processes receivs that message.\n\n![Processes](assets/pubsub.png)\n\n*This picture shows how two processes have subscribed to a topic (Or channel) \"Messages\". When another process then sends *\"Hello\"* on this topic the other two will receive it.","ref":"pubsub.html#basic-concepts"},{"type":"extras","title":"Example - Nova Pubsub","doc":"```erlang\n-module(test_module).\n-export([player1/0,\n         player2/0,\n         start_game/0]).\n\nplayer1() ->\n  spawn(fun() ->\n    nova_pubsub:join(game_of_pong),\n    game_loop(1, \"pong\", \"ping\")\n  end).\n\nplayer2() ->\n  spawn(fun() ->\n    nova_pubsub:join(game_of_pong),\n    game_loop(2, \"ping\", \"pong\")\n  end).\n\ngame_loop(Player, ExpectedMessage, Smash) ->\n  receive\n    ExpectedMessage ->\n      io:format(\"Player ~d received ~s and returning ~s~n\", [Player, ExpectedMessage, Smash]),\n      nova_pubsub:broadcast(game_of_pong, \"match1\", Smash),\n      game_loop(Player, ExpectedMessage, Smash);\n  _ ->\n      game_loop(Player, ExpectedMessage, Smash)\n  end.\n```\nHere we are subscribing to a topic *\"game_of_pong\"* which we later use to send either ping or pong to, depending on which player that are serving.\nThis can ofcourse be extended to do so much more, but this is a taste of what one can use nova_pubsub to.","ref":"pubsub.html#example"},{"type":"extras","title":"Configuration - Nova Pubsub","doc":"It does not require any specific parameters set in order to work. Just remember to enable *distributed erlang*.","ref":"pubsub.html#configuration"},{"type":"extras","title":"Building releases","doc":"# Building releases\n\nNova utilizes [relx](https://github.com/erlware/relx) for building releases and has a particular *profile* defined for creating such. In a standard Nova-project there will be two profiles defined; `dev`and `prod`. The `dev`-profile is used for local development and the `prod`-profile is used for building releases.\n\nSo in order to build a release for production, you would run the following command:\n\n```\n$ rebar3 as prod tar\n```\n\nThis builds a release and archives it into a tar-file. As default erts is included in the release, but this can be configured through the options in `rebar.config`. To read more about release handling and configuration options we recommend reading relx-manual.\n\nIf you are inexperienced with building releases we recommend reading the [relx-manual](https://www.rebar3.org/docs/releases#section-relx).","ref":"building-releases.html"},{"type":"extras","title":"Books and links","doc":"# Books and links","ref":"books-and-links.html"},{"type":"extras","title":"Online books - Books and links","doc":"* [Learn you some Erlang](https://learnyousomeerlang.com)","ref":"books-and-links.html#online-books"},{"type":"extras","title":"Books - Books and links","doc":"* [Learn you some Erlang](https://learnyousomeerlang.com)\n* [Erlang OTP in action](https://www.manning.com/books/erlang-and-otp-in-action)","ref":"books-and-links.html#books"},{"type":"extras","title":"Blogs & Articles - Books and links","doc":"* [Nova a web framework for Erlang - Daniel Widgren, Niclas Axelsson | Code BEAM V 2020](https://www.youtube.com/watch?v=rucxrxefZMA)\n* [Nova in Hello Erlang-podcast](https://www.youtube.com/watch?v=6svokoTcRes)\n* [Getting around with NOVA | Daniel Widgren, Niclas Axelsson | Code BEAM America 2022](https://www.youtube.com/watch?v=jVkhKrx4jcY)\n* [Fireside chat on Nova and Nitrogen | Daniel Widgren, Niclas Axelsson & Jesse Gumm | Code BEAM V EU21](https://www.youtube.com/watch?v=PgBzV1-E00k)","ref":"books-and-links.html#blogs-articles"},{"type":"extras","title":"Rebar3 Nova","doc":"# Rebar3 Nova #\n\nIf you have used the installation script, documented in the main README.md-file you should have a working installation of rebar3 nova. This gives you some handy commands to work with Nova;\n\n`rebar3 new nova  ` - Creates a new Nova project in the directory ` `\n\n`rebar3 nova serve` - Starts a local webserver on port given in *sys.config*, serving the current project. This means that if something is changed in the project, the server will automatically reload the changed files.\n\n`rebar3 nova routes` - Lists all routes in the current project (Includes included Nova applications aswell if they are properly configured)\n\n\nWe are hoping to increase the amount of commands that is available from the rebar3 nova command in the future.","ref":"rebar3_nova.html"}],"content_type":"text/plain"}